Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation
Class MainWindow
    Private m_LoggedIn As Boolean = False
    Friend m_OPCWPFLogin As New OPCWPFDashboard.OPCWPFLogIn
    Private CurrentTrend As String

    Private Sub mnuLogOn_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuLogOn.Click
        If m_LoggedIn Then
            m_OPCWPFLogin.LogOff()

            Dim ErrorString As String = ""
            m_LoggedIn = False
            mnuLogOn.Header = "Log In"
            mnuCurrentUser.Header = "Current User: Nobody"
            Me.OPCTrend.LogOff()
            Me.OPCAlarm.LogOff()
        Else
            Dim resultString As String
            Dim dlg As New LogIn
            dlg.Owner = Me

            dlg.ShowDialog()
            If dlg.DialogResult Then
                If dlg.TextBoxUserName.Text = "" Then
                    MessageBox.Show("User Name is blank", "Invalid User Name", MessageBoxButton.OK, MessageBoxImage.Error)
                    Exit Sub
                End If
                resultString = m_OPCWPFLogin.LogIn(dlg.TextBoxUserName.Text, dlg.PasswordBoxPassword.Password)
                If resultString <> "Success" Then
                    MessageBox.Show(resultString, "Log In " + dlg.TextBoxUserName.Text, MessageBoxButton.OK, MessageBoxImage.Error)
                    Exit Sub
                End If

                m_LoggedIn = True
                mnuLogOn.Header = "Log Off"
                mnuCurrentUser.Header = "Current User: " & dlg.TextBoxUserName.Text
                Me.OPCTrend.LogIn(dlg.TextBoxUserName.Text, dlg.PasswordBoxPassword.Password)
                Me.OPCAlarm.LogIn(dlg.TextBoxUserName.Text, dlg.PasswordBoxPassword.Password)

            End If
        End If
    End Sub

    Private Sub mnuOpenOn_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuOpen.Click
        ' Displays an OpenFileDialog so the user can select a Trend Setup.
        Dim openFileDialog1 As New Forms.OpenFileDialog()
        openFileDialog1.Filter = "Trend Files|*.Chart"
        openFileDialog1.Title = "Select a Trend File"

        ' Show the Dialog.
        ' If the user clicked OK in the dialog and 
        ' a .CHART file was selected, open it.
        If openFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.OPCTrend.StopTrendRuntime()
            Me.OPCTrend.ConfigurationFile = openFileDialog1.FileName
            My.Settings.TrendFileName = Me.OPCTrend.ConfigurationFile
            Me.OPCTrend.LoadConfiguration()
            Me.OPCTrend.StartTrendRuntime()
            CurrentTrend = openFileDialog1.FileName
            My.Settings.TrendFileName = CurrentTrend
            Me.OPCTrend.ConfigurationFile = ""
            My.Settings.Save()

        End If
    End Sub

    Private Sub mnuSaveOn_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuSave.Click
        If CurrentTrend <> "" Then

            My.Settings.TrendFileName = CurrentTrend
            OPCTrend.ConfigurationFile = CurrentTrend
            OPCTrend.SaveConfiguration()
        Else
            'Displays a SaveFileDialog so the user can save the Trend 
            Dim saveFileDialog1 As New Forms.SaveFileDialog()
            saveFileDialog1.Filter = "Trend Configuration|*.Chart"
            saveFileDialog1.Title = "Save a Trend Configuration"
            saveFileDialog1.ShowDialog()

            ' If the file name is not an empty string open it for saving.
            If saveFileDialog1.FileName <> "" Then

                My.Settings.TrendFileName = saveFileDialog1.FileName
                OPCTrend.ConfigurationFile = saveFileDialog1.FileName
                MsgBox(Me.OPCTrend.ConfigurationFile)
                OPCTrend.SaveConfiguration()
            End If
        End If
    End Sub

    Private Sub mnuSaveAsOn_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuSaveAs.Click
        'Displays a SaveFileDialog so the user can save the Trend 
        Dim saveFileDialog1 As New Forms.SaveFileDialog()
        saveFileDialog1.Filter = "Trend Configuration|*.Chart"
        saveFileDialog1.Title = "Save a Trend Configuration"
        saveFileDialog1.ShowDialog()

        ' If the file name is not an empty string open it for saving.
        If saveFileDialog1.FileName <> "" Then

            My.Settings.TrendFileName = saveFileDialog1.FileName
            My.Settings.Save()
            CurrentTrend = saveFileDialog1.FileName
            OPCTrend.ConfigurationFile = saveFileDialog1.FileName
            OPCTrend.SaveConfiguration()
            Me.OPCTrend.ConfigurationFile = ""
        End If
    End Sub
End Class
